Textfield myTextfield; 

void controlsetup () {


  controlP5 = new ControlP5(this);
  controlP5.setAutoDraw(false);

  controlP5.addBang("WRITE_INP", 10, 10, 30, 30);
  controlP5.addBang("DO_CCX", 60, 10, 30, 30);
  controlP5.addBang("DO_CGX", 110, 10, 30, 30);
  controlP5.addBang("LOAD_CCX", 160, 10, 30, 30);

  //addSlider(theName, theMin, theMax, theDefaultValue, theX, theY, theW, theH);
  controlP5.addSlider("TRANSPARENCY", 0, 255, 100, 10, 10*7, 150, 10);
  controlP5.addSlider("THRESHOLD_MAX", 0.0, 255.0, 255.0, 10, 10*9, 150, 10);
  controlP5.addSlider("THRESHOLD_MIN", 0.0, 255.0, 0.0, 10, 10*11, 150, 10);
  controlP5.addSlider("BURDEN", 0, 1000, 600, 10, 10*13, 150, 10);
  controlP5.addSlider("ELASTIC01", 0, 10000, 1000, 10, 10*15, 150, 10);
  controlP5.addSlider("ELASTIC02", 0, 1, 0.01, 10, 10*17, 150, 10);

  controlP5.addBang("GROWTH", 10, 200, 30, 30);
  controlP5.addBang("REMOVE", 10, 260, 30, 30);
  controlP5.addBang("AUTO", 50, 200, 30, 30);
  controlP5.addBang("EVOLVE", 50, 260, 30, 30);
  controlP5.addBang("STOP", 50, 320, 30, 30);
  controlP5.addBang("WRITE_DATA", 90, 260, 30, 30);

  controlP5.addButton("loadVoxel", 1, 10, 400, 80, 19);
  controlP5.addButton("setBottom", 1, 10, 430, 80, 19);
  controlP5.addButton("rotateModel", 1, 10, 490, 80, 19);
  controlP5.addButton("setWall", 1, 10, 460, 80, 19);
  controlP5.addButton("saveVoxel", 1, 10, 520, 80, 19);
  controlP5.addButton("saveBinary", 1, 10, 550, 80, 19);


}

///////////////////////////////////////////////////////////
//mousePressed
///////////////////////////////////////////////////////////
void keyPressed() {

  switch(key) {
  case '1':
    currentCell[0].change(1);
    break;
  case '2':
    currentCell[0].change(2);
    break;
  case '3':
    currentCell[0].change(3);
    break;
  case '4':
    currentCell[0].change(4);
    break;
  case '5':
    currentCell[0].change(5);
    break;
  case '6':
    currentCell[0].change(6);  
    break; 
  case '7':
    currentCell[0].change(7);
    break;
  case '8':
    currentCell[0].change(8);     
    break;
  case '9':
    currentCell[0].change(9);   
    break;
  case '0':
    currentCell[0].change(0);   
    break;
  case 'e':
    exportFlg=true;  //export
    break;
  case 'a':
    //    if (selz<blocks*gridLength - gridLength*blocks/2 - gridLength/2) {
    if (currentZ<blocks-1) {
      selz=selz+gridLength;  
      currentZ++; 
      currentCell[0] = p2[currentX][currentY][currentZ];
    }
    break;
  case 'z':
    //    if (selz>- gridLength*blocks/2 + gridLength/2) {
    if (currentZ>0) {
      selz=selz-gridLength;  
      currentZ--; 
      currentCell[0] = p2[currentX][currentY][currentZ];
    }
    break;
  case 'd':
    for (int i = 0; i < p.length; i++) {
      p[i].changex(2);
    }
    break;
  case 'f':
    for (int i = 0; i < p.length; i++) {
      p[i].changey(2);
    }
    break;
  case 'g':
    for (int i = 0; i < p.length; i++) {
      p[i].changez(2);
    }
    break;

  case '-':
    println(currentCell[0].magvalue);  
    println(currentCell[0].potential);
    break;

  case '@':
    if (exportFlg == false) exportFlg = true;
    break;
  case ';':
    loadVoxel();
    break;
  case ':':
    exchange();
    break;
  }

  switch(keyCode) {
  case DOWN:
    //    if (sely<blocks*gridLength - gridLength*blocks/2 - gridLength/2) {
    if (currentY<blocks-1) {
      sely=sely+gridLength; 
      currentY++; 
      currentCell[0] = p2[currentX][currentY][currentZ];
    }
    break;
  case UP:
    //    if (sely>- gridLength*blocks/2 + gridLength/2) {
    if (currentY>0) {
      sely=sely-gridLength; 
      currentY--; 
      currentCell[0] = p2[currentX][currentY][currentZ];
    }
    break;
  case RIGHT:
    //    if (selx<blocks*gridLength - gridLength*blocks/2 - gridLength/2) {
    if (currentX<blocks-1) {
      selx=selx+gridLength;  
      currentX++; 
      currentCell[0] = p2[currentX][currentY][currentZ];
    }
    break;
  case LEFT:
    //    if (selx>- gridLength*blocks/2 + gridLength/2) {
    if (currentX>0) {    
      selx=selx-gridLength;  
      currentX--; 
      currentCell[0] = p2[currentX][currentY][currentZ];
    }
    break;
  }
}


///////////////////////////////////////////////////////////
//mouseDragged
///////////////////////////////////////////////////////////
void mouseDragged() {
  if (keyPressed && keyCode==SHIFT) {
    //    cam.zoom((mouseY-pmouseY)*50.0);  //?��J?��?��?��?��?��?��zoom in or out
  }
  else {
    if (keyCode != ALT) {
      //      cam.tumble(radians(mouseX - pmouseX), radians(mouseY - pmouseY));
      //cam.tumble((mouseX-pmouseX)/100.0,-(mouseY-pmouseY)/100.0);  //?��J?��?��?��?��?��̎�?��_?��?��܂킷
    }
  }
}

